<?php

	require_once("../_funcdb.php");

	$struct = array();

	require("dbcabang.php");
	require("dbluntip.php");
	require("dbpelang.php");
	require("dbmutasi.php");
	require("dbuser.php");
	require("dbkontro.php");

	foreach ( $struct as $table => $cols ) {

		if ( !IsTableExists( $table ) ) {

			if ( $cols['CreateIfNotExist'] ) {

				$createtable = 'CREATE TABLE ' . $table . ' (';

				foreach ( $cols as $field => $detail ) {

					if ( $field == 'Key' ) {

						foreach ( $detail as $key => $keyvalue ) {
							$createtable = $createtable . 'KEY ' . $key . ' (' . $keyvalue . '),';
						}

					} elseif ( $field == 'UniqueKey' ) {

						foreach ( $detail as $unique => $uniquekeyvalue ) {
							if ( !array_key_exists('PrimaryKey',$cols) OR strpos( $cols['PrimaryKey'], $uniquekeyvalue ) === FALSE ) {
								$createtable = $createtable . 'UNIQUE INDEX ' . $unique . ' (' . $uniquekeyvalue . ' ASC),';
							}
						}

					} elseif ( $field == 'CreateIfNotExist' ) {
						// do nothing ...
					} else {

						if ( $field == 'PrimaryKey' ) {
							$createtable = $createtable . 'PRIMARY KEY (' . $detail . '),';
						} else {
							$createtable = $createtable . $field . ' ' . $detail . ',';
						}

					}

				}

				if ( substr( $createtable, strlen($createtable) - 1, 1 ) == ',' ) {
					$createtable = substr( $createtable, 0, strlen($createtable) - 1 );
				}

				$createtable = $createtable . ') ENGINE=InnoDB DEFAULT CHARSET=utf8';

				if ( @DBQuery( $createtable ) === false ) {
					die( "Error creating table $table" . CRLF . DBError() . CRLF . $createtable );
				}

			}

		} else {

			$updatetable = 'ALTER TABLE ' . $table . ' ';
			$compareonly = $updatetable;

			$querycols = @DBQuery( 'SHOW FULL COLUMNS FROM ' . $table );

			$primarykey = '';

			$uniquekey = array();

			$key = array();

			$curstruct = array();

			if ( $querycols ) {

				while ( $querycol = DBFetchAssoc($querycols) ) {

					$curstruct[$querycol['Field']] = $querycol['Type'] . ( $querycol['Null'] == 'YES' ? '' : ' NOT NULL' ) . ' ' . strtoupper($querycol['Extra']);

					if ( $querycol['Key'] == 'PRI' ) {
						if ( $primarykey != '' ) {
							$primarykey = $primarykey . ',';
						}
						$primarykey = $primarykey . $querycol['Field'];
					}

					if ( $querycol['Key'] == 'PRI' OR $querycol['Key'] == 'UNI' ) {
						$uniquekey[$querycol['Field']] = $querycol['Field'];
					}

					if ( $querycol['Key'] == 'MUL' ) {
						$key[$querycol['Field']] = $querycol['Field'];
					}

				}

				if ( $primarykey != '' ) {
					$curstruct['PrimaryKey'] = $primarykey;
				}

				if ( $uniquekey ) {
					$curstruct['UniqueKey'] = $uniquekey;
				}

				if ( $key ) {
					$curstruct['Key'] = $key;
				}

				$structarray = $cols;

				foreach ( $curstruct as $field => $detail ) {

					if ( $field == 'Key' ) {

						foreach ( $detail as $key => $keyvalue ) {
							if ( !array_key_exists( 'Key', $structarray ) OR !array_key_exists( $key, $structarray['Key'] ) ) {
								$updatetable = $updatetable . 'DROP INDEX ' . $key . ', ';
							}
						}

					} elseif ( $field == 'UniqueKey' ) {

						foreach ( $detail as $unique => $uniquekeyvalue ) {
							if ( !array_key_exists( 'UniqueKey', $structarray ) OR !array_key_exists( $unique, $structarray['UniqueKey'] ) ) {
								if ( !array_key_exists( 'PrimaryKey', $curstruct ) OR strpos( $curstruct['PrimaryKey'], $uniquekeyvalue ) === false ) {
									$updatetable = $updatetable . 'DROP INDEX ' . $unique . ', ';
								}
							}
						}

					} else {

						if ( $field == 'PrimaryKey' ) {
							if ( !array_key_exists( 'PrimaryKey', $structarray ) ) {
								$updatetable = $updatetable . 'DROP PRIMARY KEY, ';
							}
						} else {
							if ( !array_key_exists( $field, $structarray ) ) {
								$updatetable = $updatetable . 'DROP COLUMN ' . $field . ', ';
							}
						}

					}

				}

				$lastfield = '';

				foreach ( $cols as $field => $detail ) {

					if ( $field == 'Key' ) {

						foreach ( $detail as $key => $keyvalue ) {
							if ( array_key_exists( 'Key', $curstruct ) AND array_key_exists( $key, $curstruct['Key'] ) ) {
								if ( strtoupper(trim($keyvalue)) != strtoupper(trim($curstruct['Key'][$keyvalue])) ) {
									$updatetable = $updatetable . 'DROP INDEX ' . $key . ', ';
									$updatetable = $updatetable . 'ADD INDEX ' . $key . ' (' . $keyvalue . ' ASC), ';
								}
							} else {
								$updatetable = $updatetable . 'ADD INDEX ' . $key . ' (' . $keyvalue . ' ASC), ';
							}
						}

					} elseif ( $field == 'UniqueKey' ) {

						foreach ( $detail as $unique => $uniquekeyvalue ) {
							if ( array_key_exists( 'UniqueKey', $curstruct ) AND array_key_exists( $unique, $curstruct['UniqueKey'] ) ) {
								if ( strtoupper(trim($uniquekeyvalue)) != strtoupper(trim($curstruct['UniqueKey'][$uniquekeyvalue])) ) {
									$updatetable = $updatetable . 'DROP INDEX ' . $unique . ', ';
									$updatetable = $updatetable . 'ADD UNIQUE INDEX ' . $unique . ' (' . $uniquekeyvalue . ' ASC), ';
								}
							} else {
								if ( !array_key_exists( 'PrimaryKey', $cols ) OR strpos( $cols['PrimaryKey'], $uniquekeyvalue ) === false ) {
									$updatetable = $updatetable . 'ADD UNIQUE INDEX ' . $unique . ' (' . $uniquekeyvalue . ' ASC), ';
								}
							}
						}

					} elseif ( $field == 'CreateIfNotExist' ) {
						// do nothing ...

					} else {

						if ( $field == 'PrimaryKey' ) {
							if ( array_key_exists( 'PrimaryKey', $curstruct ) ) {
								if ( strtoupper(trim($detail)) != strtoupper(trim($curstruct['PrimaryKey'])) ) {
									$updatetable = $updatetable . 'DROP PRIMARY KEY, ';
									$updatetable = $updatetable . 'ADD PRIMARY KEY (' . $detail . '), ';
								}
							} else {
								$updatetable = $updatetable . 'ADD PRIMARY KEY (' . $detail . '), ';
							}
						} else {
							if ( !array_key_exists( $field, $curstruct ) ) {
								$updatetable = $updatetable . 'ADD COLUMN ' . $field . ' ' . $detail . ( $lastfield == '' ? ' FIRST' : ' AFTER ' . $lastfield ) . ', ';
							} else {
								if ( strtoupper(trim($detail)) != strtoupper(trim($curstruct[$field])) ) {
									$updatetable = $updatetable . 'CHANGE COLUMN ' . $field . ' ' . $field . ' ' . $detail . ', ';
								}
							}
							$lastfield = $field;
						}

					}

				}

				if ( substr( $updatetable, strlen($updatetable) - 2, 2 ) == ', ' ) {
					$updatetable = substr( $updatetable, 0, strlen($updatetable) - 2 );
				}

				if ( $compareonly != $updatetable ) {
					if ( @DBQuery( $updatetable ) === false ) {
						die( "Error updating table $table" . CRLF . DBError() . CRLF . $updatetable );
					}
				}

			} else {

				die( "Error updating table '$table': " . CRLF . DBError() . CRLF . " [query columns]" );

			}

		}

	}

	$perintahdb = "UPDATE tblcontrol SET DBVersion=" . DATABASE_VERSION;

	@DBQuery( $perintahdb );

	if ( $versilama <= 7 ) {
		$perintahdb = "UPDATE tblmutasi SET DebetEx=Debet, KreditEx=Kredit";
		@DBQuery( $perintahdb );
	}



	function IsTableExists( $table ) { 

		$sqlquery = @DBQuery("SHOW TABLES");

		while ( list($temp) = @DBFetchArray($sqlquery) ) {

			if ( $temp == $table OR $temp == strtolower($table) ) {
				return TRUE;
			}

		}

		return FALSE;
	}
?>